#!/bin/bash

MODEL=`cat /proc/deviceinfo/product`
ROTA=`xrandr | grep 'Current rotation' | sed -e 's/Current rotation\ \-\ //g'`
# This part is needed in a special case:
# The Z is closed so slow that it first jumps to portrait, because
# the rotate sensor gets pushed first and then the close sensor
# (the one above 1-2 keys) just after that.
# So this part restores the screen back to landscape before turning
# off the screen, this way the load time when Z is opened gets much
# shorter.
case "$MODEL" in
    SL-6000)
        ;;
    *)
        touch $HOME/.fvwm/closed
	fvwm-landscape.sh
        ;;
esac

# Switch off the screen
/usr/X11R6/bin/xset s activate
