#!/usr/bin/env python
#
# This script generates Fvwm menu from the *.desktop files
# Written by Zumi, 2005
#

import os, re

WORKPATH = "/usr/share/applications/"

filelist = os.listdir(WORKPATH)
filelist.sort()
action = []
office = []
multimedia = []
development = []
network = []
graphics = []
games = []
other = []
systools = []

def make_line(fp):
	appexec = ""
	appname = ""
	for line in fp:
		if re.search("^Exec=", line):
			appexec = re.sub("^Exec=", "", line[:-1])
		if re.search("^Name=", line):
			appname = re.sub("^Name=", "", line[:-1])
			appname = re.sub("&", "&&", appname)
		if appexec != "" and appname != "":
			outputline = "+ \"" + appname + "\" Exec exec " + appexec;
			return outputline


for file in filelist:
	fp = open(WORKPATH + file, "r")
	for line in fp:
		if re.search("^Categories", line):
			cate = re.sub("^Categories=", "", line)
			if re.search("Action", cate):
				action.append(file)
			elif re.search("Office", cate):
				office.append(file)
			elif re.search("AudioVideo", cate):
				multimedia.append(file)
			elif re.search("Development", cate):
				development.append(file)
			elif re.search("Network", cate):
				network.append(file)
			elif re.search("Graphics", cate):
				graphics.append(file)
			elif re.search("Games", cate):
				games.append(file)
			elif re.search("Applications", cate):
				other.append(file)
			elif re.search("SystemSettings", cate):
				systools.append(file)
				
	fp.close()

#catelist = [ action, office, multimedia, development, network, graphics, games, other, systools ]
catenamelist = [ "office", "multimedia", "development", "network", "graphics", "games", "other", "systools", "action" ]
it = iter(catenamelist)

catelist = [ office, multimedia, development, network, graphics, games, other, systools, action ]

for category in catelist:
	menulist = []
	for file in category:
		fp = open(WORKPATH + file, "r")
		menulist.append(make_line(fp))
	categoryname = it.next()
	if len(menulist) > 0:
		menulist.sort()
		print "DestroyMenu " + categoryname
		print "AddToMenu " + categoryname
		for item in menulist:
			print item
		print ""

print "AddToMenu MenuFvwmRoot"
if len(development) > 0:
	print "+ %24x24/mbfolder_programming.png%\"Programming\" Popup development"
if len(office) > 0:
	print "+ %24x24/mbfolder_office.png%\"Office\" Popup office"
if len(network) > 0:
	print "+ %24x24/mbfolder_internet.png%\"Internet\" Popup network"
if len(multimedia) > 0:
	print "+ %24x24/mbfolder_multimedia.png%\"Sound && Video\" Popup multimedia"
if len(graphics) > 0:
	print "+ %24x24/mbfolder_graphics.png%\"Graphics\" Popup graphics"
if len(games) > 0:
	print "+ %24x24/mbfolder_games.png%\"Games\" Popup games"
if len(other) > 0:
	print "+ %24x24/mbfolder_other.png%\"Other\" Popup other"
if len(systools) > 0:
	print "+ %24x24/mbfolder_system.png%\"System Tools\" Popup systools"

