#!/bin/bash

FVWMCOMMAND=`which FvwmCommand`
RUNCOMMAND="xvkbd -modal -no-keypad -geometry 480x120+0-30 -dict /usr/share/dict/xvkbd.dic"

if [ -e $HOME/.fvwm/xvkbd.pid ] ; then
  PID=`cat $HOME/.fvwm/xvkbd.pid`
  PSOUT=`ps x|grep "^[ \t]*$PID"|sed "s/^[ \t]*[0-9]*[ \t]*[0-9a-zA-Z]*[ \t]*[0-9]*[ \t]*[0-9a-zA-Z]*[ \t]*\([0-9a-zA-Z]*\).*/\1/"`
  if [ "$PSOUT" == "xvkbd" ] ; then
    kill -9 $PID
    rm $HOME/.fvwm/xvkbd.pid
    $FVWMCOMMAND 'DestroyFunc ZaurusMaximize'
    $FVWMCOMMAND 'AddToFunc ZaurusMaximize I Maximize $0 480p 608p'
    $FVWMCOMMAND 'All (Maximized) ZaurusMaximize true'
  else
    rm $HOME/.fvwm/xvkbd.pid
    $RUNCOMMAND &
    echo $! > $HOME/.fvwm/xvkbd.pid
    $FVWMCOMMAND 'DestroyFunc ZaurusMaximize'
    $FVWMCOMMAND 'AddToFunc ZaurusMaximize I Maximize $0 480p 488p'
    $FVWMCOMMAND 'All (Maximized) ZaurusMaximize true'
  fi
else
  $RUNCOMMAND &
  echo $! > $HOME/.fvwm/xvkbd.pid
  $FVWMCOMMAND 'DestroyFunc ZaurusMaximize'
  $FVWMCOMMAND 'AddToFunc ZaurusMaximize I Maximize $0 480p 488p'
  $FVWMCOMMAND 'All (Maximized) ZaurusMaximize true'
fi

