#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>

#define PLAY_MIXER "/dev/dsp"

int get()
{
	int play_fp;
	int status = 0, level = 0;

	if ((play_fp = open(PLAY_MIXER, 0)) == -1)
		perror("Failed to open PLAY_MIXER");
	status = ioctl(play_fp, MIXER_READ(0), &level);
	//printf("level: left=%d%%, right=%d%%\n", level & 0xff, (level & 0xff00) >> 8);
	close(play_fp);
	return level & 0xff;
}

int set(int level)
{
	int play_fp, status, mix_level;
//	int level = 100;

	if ((play_fp = open(PLAY_MIXER, 0)) == -1)
		perror("failed to open PLAY_MIXER");
	mix_level = level + (level << 8);
	status = ioctl(play_fp, MIXER_WRITE(0), &mix_level);
	if (status == -1) {
		close(play_fp);
		perror("MIXER_WRITE ioctl failed");
		return -1;
	}
	close(play_fp);
}

void volmenu()
{
	int volume = 0;
	char v000[20] = "";
	char v010[20] = "";
	char v020[20] = "";
	char v030[20] = "";
	char v040[20] = "";
	char v050[20] = "";
	char v060[20] = "";
	char v070[20] = "";
	char v080[20] = "";
	char v090[20] = "";
	char v100[20] = "";
	volume = get();
	printf("%d\n", volume);
	if (volume < 5) {
		strcpy(v000, "%selected.png%");
	} else if (volume >= 5 && volume < 15) {
		strcpy(v010, "%selected.png%");
		printf("malac\n");
	} else if (volume >= 15 && volume < 25) {
		strcpy(v020, "%selected.png%");
	} else if (volume >= 25 && volume < 35) {
		strcpy(v030, "%selected.png%");
	} else if (volume >= 35 && volume < 45) {
		strcpy(v040, "%selected.png%");
	} else if (volume >= 45 && volume < 55) {
		strcpy(v050, "%selected.png%");
	} else if (volume >= 55 && volume < 65) {
		strcpy(v060, "%selected.png%");
	} else if (volume >= 65 && volume < 75) {
		strcpy(v070, "%selected.png%");
	} else if (volume >= 75 && volume < 85) {
		strcpy(v080, "%selected.png%");
	} else if (volume >= 85 && volume < 95) {
		strcpy(v090, "%selected.png%");
	} else if (volume >= 95) {
		strcpy(v100, "%selected.png%");
	}
					      
	printf("DestroyMenu recreate VolMenu\n\
AddToMenu VolMenu\n\
+ \"Volume\"\n\
+ \"\" Nop\n\
+ %s\"0%\" Exec exec $[HOME]/.fvwm/zvol 0\n\
+ %s\"10%\" Exec exec $[HOME]/.fvwm/zvol 10\n\
+ %s\"20%\" Exec exec $[HOME]/.fvwm/zvol 20\n\
+ %s\"30%\" Exec exec $[HOME]/.fvwm/zvol 30\n\
+ %s\"40%\" Exec exec $[HOME]/.fvwm/zvol 40\n\
+ %s\"50%\" Exec exec $[HOME]/.fvwm/zvol 50\n\
+ %s\"60%\" Exec exec $[HOME]/.fvwm/zvol 60\n\
+ %s\"70%\" Exec exec $[HOME]/.fvwm/zvol 70\n\
+ %s\"80%\" Exec exec $[HOME]/.fvwm/zvol 80\n\
+ %s\"90%\" Exec exec $[HOME]/.fvwm/zvol 90\n\
+ %s\"100%\" Exec exec $[HOME]/.fvwm/zvol 100\n\
\
", v000, v010, v020, v030, v040, v050, v060, v070, v080, v090, v100);
}

int main(int argc, char *argv[])
{
	int level = 0;
	if (argc == 2) {
		level = atoi(argv[1]);
		set(level);
	}
	else {
		//printf("%d\n", get());
		volmenu();
	}
}
